unit Clock_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.88.1.0.1.0  $
// File generated on 18/07/2000 11:25:25 from Type Library described below.

// *************************************************************************//
// NOTE:                                                                      
// Items guarded by $IFDEF_LIVE_SERVER_AT_DESIGN_TIME are used by properties  
// which return objects that may need to be explicitly created via a function 
// call prior to any access via the property. These items have been disabled  
// in order to prevent accidental use from within the object inspector. You   
// may enable them by defining LIVE_SERVER_AT_DESIGN_TIME or by selectively   
// removing them from the $IFDEF blocks. However, such items must still be    
// programmatically created via a method of the appropriate CoClass before    
// they can be used.                                                          
// ************************************************************************ //
// Type Lib: D:\TEMP\EXE BIN\CLOCK.EXE (1)
// IID\LCID: {5C901960-5BDB-11D4-96EC-0060978E1359}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  ClockMajorVersion = 1;
  ClockMinorVersion = 0;

  LIBID_Clock: TGUID = '{5C901960-5BDB-11D4-96EC-0060978E1359}';

  IID_IApplication: TGUID = '{5C901961-5BDB-11D4-96EC-0060978E1359}';
  DIID_IApplicationEvents: TGUID = '{5C901963-5BDB-11D4-96EC-0060978E1359}';
  CLASS_Application: TGUID = '{5C901965-5BDB-11D4-96EC-0060978E1359}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IApplication = interface;
  IApplicationDisp = dispinterface;
  IApplicationEvents = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Application = IApplication;


// *********************************************************************//
// Interface: IApplication
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {5C901961-5BDB-11D4-96EC-0060978E1359}
// *********************************************************************//
  IApplication = interface(IDispatch)
    ['{5C901961-5BDB-11D4-96EC-0060978E1359}']
    function  Get_CurrentDateTime: TDateTime; safecall;
    function  Get_Alarm: TDateTime; safecall;
    procedure Set_Alarm(Value: TDateTime); safecall;
    function  Get_AlarmSet: WordBool; safecall;
    property CurrentDateTime: TDateTime read Get_CurrentDateTime;
    property Alarm: TDateTime read Get_Alarm write Set_Alarm;
    property AlarmSet: WordBool read Get_AlarmSet;
  end;

// *********************************************************************//
// DispIntf:  IApplicationDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {5C901961-5BDB-11D4-96EC-0060978E1359}
// *********************************************************************//
  IApplicationDisp = dispinterface
    ['{5C901961-5BDB-11D4-96EC-0060978E1359}']
    property CurrentDateTime: TDateTime readonly dispid 1;
    property Alarm: TDateTime dispid 2;
    property AlarmSet: WordBool readonly dispid 3;
  end;

// *********************************************************************//
// DispIntf:  IApplicationEvents
// Flags:     (4096) Dispatchable
// GUID:      {5C901963-5BDB-11D4-96EC-0060978E1359}
// *********************************************************************//
  IApplicationEvents = dispinterface
    ['{5C901963-5BDB-11D4-96EC-0060978E1359}']
    procedure AlarmRing(const Clock: IApplication; AlarmTime: TDateTime); dispid 1;
    procedure AlarmSet(const Clock: IApplication; AlarmTime: TDateTime); dispid 2;
  end;

// *********************************************************************//
// The Class CoApplication provides a Create and CreateRemote method to          
// create instances of the default interface IApplication exposed by              
// the CoClass Application. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoApplication = class
    class function Create: IApplication;
    class function CreateRemote(const MachineName: string): IApplication;
  end;

  TApplicationAlarmRing = procedure(Sender: TObject; var Clock: OleVariant;AlarmDateTime: TDateTime) of object;
  TApplicationAlarmSet = procedure(Sender: TObject; var Clock: OleVariant;AlarmDateTime: TDateTime) of object;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TApplication
// Help String      : Application Object
// Default Interface: IApplication
// Def. Intf. DISP? : No
// Event   Interface: IApplicationEvents
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TApplicationProperties= class;
{$ENDIF}
  TApplication = class(TOleServer)
  private
    FOnAlarmRing: TApplicationAlarmRing;
    FOnAlarmSet: TApplicationAlarmSet;
    FIntf:        IApplication;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TApplicationProperties;
    function      GetServerProperties: TApplicationProperties;
{$ENDIF}
    function      GetDefaultInterface: IApplication;
  protected
    procedure InitServerData; override;
    procedure InvokeEvent(DispID: TDispID; var Params: TVariantArray); override;
    function  Get_CurrentDateTime: TDateTime;
    function  Get_Alarm: TDateTime;
    procedure Set_Alarm(Value: TDateTime);
    function  Get_AlarmSet: WordBool;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IApplication);
    procedure Disconnect; override;
    property  DefaultInterface: IApplication read GetDefaultInterface;
    property CurrentDateTime: TDateTime read Get_CurrentDateTime;
    property AlarmSet: WordBool read Get_AlarmSet;
    property Alarm: TDateTime read Get_Alarm write Set_Alarm;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TApplicationProperties read GetServerProperties;
{$ENDIF}
    property OnAlarmRing: TApplicationAlarmRing read FOnAlarmRing write FOnAlarmRing;
    property OnAlarmSet: TApplicationAlarmSet read FOnAlarmSet write FOnAlarmSet;
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TApplication
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TApplicationProperties = class(TPersistent)
  private
    FServer:    TApplication;
    function    GetDefaultInterface: IApplication;
    constructor Create(AServer: TApplication);
  protected
    function  Get_CurrentDateTime: TDateTime;
    function  Get_Alarm: TDateTime;
    procedure Set_Alarm(Value: TDateTime);
    function  Get_AlarmSet: WordBool;
  public
    property DefaultInterface: IApplication read GetDefaultInterface;
  published
    property Alarm: TDateTime read Get_Alarm write Set_Alarm;
  end;
{$ENDIF}


procedure Register;

implementation

uses ComObj;

class function CoApplication.Create: IApplication;
begin
  Result := CreateComObject(CLASS_Application) as IApplication;
end;

class function CoApplication.CreateRemote(const MachineName: string): IApplication;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Application) as IApplication;
end;

procedure TApplication.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{5C901965-5BDB-11D4-96EC-0060978E1359}';
    IntfIID:   '{5C901961-5BDB-11D4-96EC-0060978E1359}';
    EventIID:  '{5C901963-5BDB-11D4-96EC-0060978E1359}';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TApplication.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    ConnectEvents(punk);
    Fintf:= punk as IApplication;
  end;
end;

procedure TApplication.ConnectTo(svrIntf: IApplication);
begin
  Disconnect;
  FIntf := svrIntf;
  ConnectEvents(FIntf);
end;

procedure TApplication.DisConnect;
begin
  if Fintf <> nil then
  begin
    DisconnectEvents(FIntf);
    FIntf := nil;
  end;
end;

function TApplication.GetDefaultInterface: IApplication;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TApplication.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TApplicationProperties.Create(Self);
{$ENDIF}
end;

destructor TApplication.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TApplication.GetServerProperties: TApplicationProperties;
begin
  Result := FProps;
end;
{$ENDIF}

procedure TApplication.InvokeEvent(DispID: TDispID; var Params: TVariantArray);
begin
  case DispID of
    -1: Exit;  // DISPID_UNKNOWN
   1: if Assigned(FOnAlarmRing) then
            FOnAlarmRing(Self, Params[0] {const IApplication}, Params[1] {TDateTime});
   2: if Assigned(FOnAlarmSet) then
            FOnAlarmSet(Self, Params[0] {const IApplication}, Params[1] {TDateTime});
  end; {case DispID}
end;

function  TApplication.Get_CurrentDateTime: TDateTime;
begin
  Result := DefaultInterface.Get_CurrentDateTime;
end;

function  TApplication.Get_Alarm: TDateTime;
begin
  Result := DefaultInterface.Get_Alarm;
end;

procedure TApplication.Set_Alarm(Value: TDateTime);
begin
  DefaultInterface.Set_Alarm(Value);
end;

function  TApplication.Get_AlarmSet: WordBool;
begin
  Result := DefaultInterface.Get_AlarmSet;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TApplicationProperties.Create(AServer: TApplication);
begin
  inherited Create;
  FServer := AServer;
end;

function TApplicationProperties.GetDefaultInterface: IApplication;
begin
  Result := FServer.DefaultInterface;
end;

function  TApplicationProperties.Get_CurrentDateTime: TDateTime;
begin
  Result := DefaultInterface.Get_CurrentDateTime;
end;

function  TApplicationProperties.Get_Alarm: TDateTime;
begin
  Result := DefaultInterface.Get_Alarm;
end;

procedure TApplicationProperties.Set_Alarm(Value: TDateTime);
begin
  DefaultInterface.Set_Alarm(Value);
end;

function  TApplicationProperties.Get_AlarmSet: WordBool;
begin
  Result := DefaultInterface.Get_AlarmSet;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('ActiveX',[TApplication]);
end;

end.
