unit HierarchyClientMainForm;

interface

uses
  Hierarchy_TLB,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  THierarchyClientForm = class(TForm)
    Timer1: TTimer;
    lblDateTime: TLabel;
    lblDate: TLabel;
    lblTime: TLabel;
    lblDayOfWeek: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    Server: IApplication;
    Clock: IClock;
  end;

var
  HierarchyClientForm: THierarchyClientForm;

implementation

uses
  ComObj;

{$R *.DFM}

procedure THierarchyClientForm.FormCreate(Sender: TObject);
begin
  Server := CreateOleObject('Hierarchy.Application') as IApplication;
  Clock := Server.Clock
end;

procedure THierarchyClientForm.Timer1Timer(Sender: TObject);
begin
  try
    lblDateTime.Caption := DateTimeToStr(Clock.DateTime);
    lblDate.Caption := DateToStr(Clock.Date);
    lblTime.Caption := TimeToStr(Clock.Time);
    lblDayOfWeek.Caption := LongDayNames[Clock.DayOfWeek]
  except
    lblDateTime.Caption := 'N/A';
    lblDate.Caption := 'N/A';
    lblTime.Caption := 'N/A';
    lblDayOfWeek.Caption := 'N/A'
  end
end;

end.
