unit ClockImpl;

interface

uses
  ComObj, ActiveX, Hierarchy_TLB, StdVcl;

type
  TClock = class(TAutoIntfObject, IClock)
  protected
    function Get_Date: TDateTime; safecall;
    function Get_DateTime: TDateTime; safecall;
    function Get_DayOfWeek: TDayOfWeek; safecall;
    function Get_Time: TDateTime; safecall;
    { Protected declarations }
  end;

implementation

uses
  SysUtils;

function TClock.Get_Date: TDateTime;
begin
  Result := Date
end;

function TClock.Get_DateTime: TDateTime;
begin
  Result := Now
end;

function TClock.Get_DayOfWeek: TDayOfWeek;
begin
  Result := DayOfWeek(Now)
end;

function TClock.Get_Time: TDateTime;
begin
  Result := Time
end;

end.
