unit Hierarchy_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.88.1.0.1.0  $
// File generated on 25/07/2000 11:59:33 from Type Library described below.

// ************************************************************************ //
// Type Lib: D:\Talks\Conferences\ICon UK 2000\More Automation In Delphi\Files\Hierarchy 2\Server\Hierarchy.tlb (1)
// IID\LCID: {863DAAC0-5CA3-11D4-96EC-0060978E1359}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  HierarchyMajorVersion = 1;
  HierarchyMinorVersion = 0;

  LIBID_Hierarchy: TGUID = '{863DAAC0-5CA3-11D4-96EC-0060978E1359}';

  IID_IApplication: TGUID = '{863DAAC1-5CA3-11D4-96EC-0060978E1359}';
  CLASS_Application: TGUID = '{863DAAC3-5CA3-11D4-96EC-0060978E1359}';
  IID_IClock: TGUID = '{D7516D66-5E66-11D4-96EC-0060978E1359}';
  CLASS_Clock: TGUID = '{D7516D68-5E66-11D4-96EC-0060978E1359}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum TDayOfWeek
type
  TDayOfWeek = TOleEnum;
const
  dowSunday = $00000001;
  dowMonday = $00000002;
  dowTuesday = $00000003;
  dowWednesday = $00000004;
  dowThursday = $00000005;
  dowFriday = $00000006;
  dowSaturday = $00000007;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IApplication = interface;
  IApplicationDisp = dispinterface;
  IClock = interface;
  IClockDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Application = IApplication;
  Clock = IClock;


// *********************************************************************//
// Interface: IApplication
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {863DAAC1-5CA3-11D4-96EC-0060978E1359}
// *********************************************************************//
  IApplication = interface(IDispatch)
    ['{863DAAC1-5CA3-11D4-96EC-0060978E1359}']
    function  Get_Clock: IClock; safecall;
    property Clock: IClock read Get_Clock;
  end;

// *********************************************************************//
// DispIntf:  IApplicationDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {863DAAC1-5CA3-11D4-96EC-0060978E1359}
// *********************************************************************//
  IApplicationDisp = dispinterface
    ['{863DAAC1-5CA3-11D4-96EC-0060978E1359}']
    property Clock: IClock readonly dispid 1;
  end;

// *********************************************************************//
// Interface: IClock
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D7516D66-5E66-11D4-96EC-0060978E1359}
// *********************************************************************//
  IClock = interface(IDispatch)
    ['{D7516D66-5E66-11D4-96EC-0060978E1359}']
    function  Get_DateTime: TDateTime; safecall;
    function  Get_Date: TDateTime; safecall;
    function  Get_Time: TDateTime; safecall;
    function  Get_DayOfWeek: TDayOfWeek; safecall;
    function  Get_Application: IApplication; safecall;
    property DateTime: TDateTime read Get_DateTime;
    property Date: TDateTime read Get_Date;
    property Time: TDateTime read Get_Time;
    property DayOfWeek: TDayOfWeek read Get_DayOfWeek;
    property Application: IApplication read Get_Application;
  end;

// *********************************************************************//
// DispIntf:  IClockDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D7516D66-5E66-11D4-96EC-0060978E1359}
// *********************************************************************//
  IClockDisp = dispinterface
    ['{D7516D66-5E66-11D4-96EC-0060978E1359}']
    property DateTime: TDateTime readonly dispid 1;
    property Date: TDateTime readonly dispid 2;
    property Time: TDateTime readonly dispid 3;
    property DayOfWeek: TDayOfWeek readonly dispid 4;
    property Application: IApplication readonly dispid 5;
  end;

// *********************************************************************//
// The Class CoApplication provides a Create and CreateRemote method to          
// create instances of the default interface IApplication exposed by              
// the CoClass Application. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoApplication = class
    class function Create: IApplication;
    class function CreateRemote(const MachineName: string): IApplication;
  end;

// *********************************************************************//
// The Class CoClock provides a Create and CreateRemote method to          
// create instances of the default interface IClock exposed by              
// the CoClass Clock. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoClock = class
    class function Create: IClock;
    class function CreateRemote(const MachineName: string): IClock;
  end;

implementation

uses ComObj;

class function CoApplication.Create: IApplication;
begin
  Result := CreateComObject(CLASS_Application) as IApplication;
end;

class function CoApplication.CreateRemote(const MachineName: string): IApplication;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Application) as IApplication;
end;

class function CoClock.Create: IClock;
begin
  Result := CreateComObject(CLASS_Clock) as IClock;
end;

class function CoClock.CreateRemote(const MachineName: string): IClock;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Clock) as IClock;
end;

end.
